--[[

	this file conatins everything which is neccecary to configure via rock
	
--]]

function SmartMount:OnInitialize()
	local L = self.L

	self.options = {
		type = 'group',
		name = 'SmartMount',
		desc = [[The One-Key-Mount™

Simple to use, configured with Rock]],
		icon = 'Interface\\Icons\\Ability_Mount_BlackPanther',
		child_get = 'GetSetting',
		child_set = 'SetSetting',
		child_child_get = 'GetSetting',
		child_child_set = 'SetSetting',
		child_child_child_get = 'GetSetting',
		child_child_child_set = 'SetSetting',
		child_child_child_child_get = 'GetSetting',
		child_child_child_child_set = 'SetSetting',
		args = {
			{
				order = 1,
				type = 'keybinding',
				name = L['Normal Mount'],
				desc = L.normal_key_desc,
				passValue = 'NormalKey',
				disabled = InCombatLockdown,
			},
			{
				order = 2,
				type = 'keybinding',
				name = L['Alternate Mount'],
				desc = L.alternate_key_desc,
				passValue = 'AlternateKey',
				disabled = InCombatLockdown,
			},
			{
				order = 3,
				type = 'execute',
				name = L.key_helper_name,
				desc = L.key_helper_desc,
				confirmText = L.key_helper_confirm,
				buttonText = L.key_helper_button,
				func = 'ImportKeys'
			},
			{
				order = 4,
				type = 'boolean',
				name = L.show_action_button_name,
				desc = L.show_action_button_desc,
				passValue = 'ShowActionButton',
				disabled = InCombatLockdown,
			},
			{
				order = 5,
				type = 'boolean',
				name = L.debug_name,
				desc = L.debug_desc,
				passValue = 'Debug',
			},
			{
				order = 1,
				type = 'group',
				name = L.combat_name,
				desc = L.combat_desc,
				disabled = InCombatLockdown,
				args = {
					{
						order = 1,
						type = 'group',
						name = L['Normal Mount'],
						desc = L.grp_normal_desc,
						groupType = 'inline',
						args = {
							self:getCfgDismount('CombatNrm', true),
							self:getCfgMount(2, L.grp_mount, L.grp_mount_desc, 'CombatNrm', 2),
						},
					},
					{
						order = 2,
						type = 'group',
						name = L['Alternate Mount'],
						desc = L.grp_alternate_desc,
						groupType = 'inline',
						args = {
							self:getCfgDismount('CombatAlt', true),
							self:getCfgMount(2, L.grp_mount, L.grp_mount_desc, 'CombatAlt', 2),
						},
					},
				},
			},
			{
				order = 2,
				type = 'group',
				name = L.swim_name,
				desc = L.swim_desc,
				args = {
					{
						order = 1,
						type = 'group',
						name = L['Normal Mount'],
						desc = L.grp_normal_desc,
						groupType = 'inline',
						args = {
							self:getCfgDismount('SwimNrm', false),
							self:getCfgMount(2, L.grp_mount, L.grp_mount_desc, 'SwimNrm', 1),
						},
					},
					{
						order = 2,
						type = 'group',
						name = L['Alternate Mount'],
						desc = L.grp_alternate_desc,
						groupType = 'inline',
						args = {
							self:getCfgDismount('SwimAlt', false),
							self:getCfgMount(2, L.grp_mount, L.grp_mount_desc, 'SwimAlt', 1),
						},
					},
				},
			},
			{
				order = 3,
				type = 'group',
				name = L.dis_name,
				desc = L.dis_desc,
				args = {
					{
						order = 1,
						type = 'group',
						name = L['Normal Mount'],
						desc = L.grp_normal_desc,
						groupType = 'inline',
						args = {
							{
								order = 1,
								type = 'choice',
								name = L.grp_dismount_yes,
								desc = L.grp_dismount_yes_desc,
								choices = {
									['-M'] = L.grp_dismount_mnt__M,
									['DM'] = L.grp_dismount_mnt_DM,
									['-Mf'] = L.grp_dismount_mnt__Mf,
									['DMf'] = L.grp_dismount_mnt_DMf,
								},
								choiceType = 'dict',
								passValue = 'DisNrm' .. 'DisIfM',
							},
							self:getCfgMount(2, L.grp_mount, L.grp_mount_desc, 'DisNrm', 3),
						},
					},
					{
						order = 2,
						type = 'group',
						name = L['Alternate Mount'],
						desc = L.grp_alternate_desc,
						groupType = 'inline',
						args = {
							{
								order = 1,
								type = 'choice',
								name = L.grp_dismount_yes,
								desc = L.grp_dismount_yes_desc,
								choices = {
									['-M'] = L.grp_dismount_mnt__M,
									['DM'] = L.grp_dismount_mnt_DM,
									['-Mf'] = L.grp_dismount_mnt__Mf,
									['DMf'] = L.grp_dismount_mnt_DMf,
								},
								choiceType = 'dict',
								passValue = 'DisAlt' .. 'DisIfM',
							},
							self:getCfgMount(2, L.grp_mount, L.grp_mount_desc, 'DisAlt', 3),
						},
					},
				},
			},
			{
				order = 4,
				type = 'group',
				name = L.land_name,
				desc = L.land_desc,
				args = {
					self:getCfgMount(1, L['Normal Mount'], L.grp_normal_desc, 'LandNrm', 0),
					self:getCfgMount(2, L['Alternate Mount'], L.grp_alternate_desc, 'LandAlt', 0),
				},
			},
			{
				order = 5,
				type = 'group',
				name = 'Help',
				desc = 'Do you need help?',
				child_set = function(k, v) end,
				child_func = function() end,
				args = {
					{
						order = 1,
						type = 'execute',
						name = 'Help',
						desc = 'It\'s easy.',
						buttonText = 'Read always the ToolTips!',
					},
					{
						order = 2,
						type = 'group',
						groupType = 'inline',
						name = 'Mounts are ...',
						desc = 'This list shows you, what this addon counts as mounts.',
						args = {
							{
								order = 1,
								type = 'string',
								name = 'Regular Mounts',
								get = function() return ' e.g. Reins of the Striped Nightsaber' end,
								desc = '',
								usage = '',
								disabled = true,
							},
							{
								order = 2,
								type = 'string',
								name = 'Summoned Mounts',
								get = function() return ' ' .. SmartMount.SpellLocale['Summon Charger'] .. ', ' .. SmartMount.SpellLocale['Summon Felsteed'] .. ', ...' end,
								desc = '',
								usage = '',
								disabled = true,
							},
							{
								order = 3,
								type = 'string',
								name = 'Druid Forms',
								get = function() return ' ' .. SmartMount.SpellLocale['Travel Form'] .. ', ' .. L['Flight / Swift Flight Form'] end,
								desc = '',
								usage = '',
								disabled = true,
							},
							{
								order = 4,
								type = 'string',
								name = 'Shaman Form',
								get = function() return ' ' .. SmartMount.SpellLocale['Ghost Wolf'] end,
								desc = '',
								usage = '',
								disabled = true,
							},
						},
					},
					{
						order = 3,
						type = 'execute',
						name = 'Macro',
						desc = 'This will create an macro, which can be used like this:\n\nLeft Click = Normal Mount\nOther Click = Alternate Mount',
						buttonText = 'Create a Macro',
						func = 'createMacro',
						disabled = InCombatLockdown,
					},
					{
						order = 4,
						type = 'execute',
						name = 'LibPeriodicTable-3.1',
						desc = 'This Addon makes it (for SmartMount) possible to summon a random pet after dismounting.',
						buttonText = 'Get URL',
						func = function() self:DisplayURL([[http://files.wowace.com/LibPeriodicTable-3.1/LibPeriodicTable-3.1.zip]]) end,
					},
					{
						order = 5,
						type = 'execute',
						name = 'Menagerie',
						desc = 'This is an Addon which swaps minipets and mounts when visiting the bank — which makes it even more random.',
						buttonText = 'Get URL',
						func = function() self:DisplayURL([[http://files.wowace.com/Menagerie/Menagerie.zip]]) end,
					},
					{
						order = 6,
						type = 'string',
						name = 'Inspiration',
						desc = '',
						get = function() return [[ Inspired by Timo's RandomMount Macro and Tabethial's RandomPet Addon]] end,
						usage = '',
						disabled = true,
					},
					{
						order = 7,
						type = 'string',
						name = L['Translator'],
						desc = '',
						get = function() return L['translated_by'] end,
						usage = '',
						disabled = true,
					},
				},
			},
		},
	}

	SmartMount:SetConfigTable(self.options)
end

function SmartMount:createMacro()
	if GetMacroIndexByName('SmartMount') == 0 then
		local icon, numicons, i = 1, GetNumMacroIcons()
		for i=1, numicons do
			if GetMacroIconInfo(i) == 'Interface\\Icons\\Ability_Mount_BlackPanther' then
				icon = i
			end -- if
		end -- for
		CreateMacro('SmartMount', icon, '/click [button:1] SmartMount_Button ; SmartMount_Button RightButton', 1, 0)
	end
end

function SmartMount:DisplayURL(theLink)
	-- thanks to WIM
	
	-- The following code was written by the creator of Prat.
	StaticPopupDialogs['SMARTMOUNT_SHOW_URL'] = {
		text = 'URL : %s',
		button2 = TEXT(ACCEPT),
		hasEditBox = 1,
		hasWideEditBox = 1,
		showAlert = 1, -- HACK : it's the only way I found to make de StaticPopup have sufficient width to show WideEditBox :(

		OnShow = function()
			local editBox = getglobal(this:GetName()..'WideEditBox');
			editBox:SetText(format(theLink));
			editBox:SetFocus();
			editBox:HighlightText(0);

			local button = getglobal(this:GetName()..'Button2');
			button:ClearAllPoints();
			button:SetWidth(200);
			button:SetPoint('CENTER', editBox, 'CENTER', 0, -30);

			getglobal(this:GetName()..'AlertIcon'):Hide();  -- HACK : we hide the false AlertIcon
		end,

		OnHide = function() end,
		OnAccept = function() end,
		OnCancel = function() end,
		EditBoxOnEscapePressed = function() this:GetParent():Hide() end,
		timeout = 0,
		whileDead = 1,
		hideOnEscape = 1,
	}

	StaticPopup_Show ('SMARTMOUNT_SHOW_URL', theLink);
end



function SmartMount:getCfgDismount(prefix, mustmount)
	local L = self.L

	local cd = {
			['-M'] = L.grp_dismount_yes__M,
			['DM'] = L.grp_dismount_yes_DM,
		}

	local cm = {
			['-M'] = L.grp_dismount_no__M,
		}

	if not mustmount then
		cd['--'] = L.grp_dismount_yes___
		cd['D-'] = L.grp_dismount_yes_D_
		cm['--'] = L.grp_dismount_no___
	end -- if

	return
		{
			order = 1,
			type = 'group',
			name = L.grp_dismount,
			desc = L.grp_dismount_desc,
			groupType = 'inline',
			args = {
				{
					order = 1,
					type = 'choice',
					name = L.grp_dismount_yes,
					desc = L.grp_dismount_yes_desc,
					choices = cd,
					choiceType = 'dict',
					passValue = prefix .. 'DisIfM',
				},
				{
					order = 2,
					type = 'choice',
					name = L.grp_dismount_no,
					desc = L.grp_dismount_no_desc,
					choices = cm,
					choiceType = 'dict',
					passValue = prefix .. 'DisNot',
				},
			},
		}
end

function SmartMount:getCfgMount(order, name, desc, prefix, mode)
	local L = self.L

	return
		{
			order = order,
			type = 'group',
			name = name,
			desc = desc,
			groupType = 'inline',
			args = {
				{
					order = 1,
					type = 'choice',
					name = L.grp_mount_1st,
					desc = L.grp_mount_1st2nd_desc,
					choices = function() return self:GetListOfMounts(mode) end,
					choiceIcons = 'GetListOfMountIcons',
					choiceOrder = 'GetListOfMountOrder',
					choiceType = 'dict',
					passValue = prefix .. 'Mount1',
				},
				{
					order = 2,
					type = 'choice',
					name = L.grp_mount_2nd,
					desc = L.grp_mount_1st2nd_desc,
					choices = function() return self:GetListOfMounts(mode) end,
					choiceIcons = 'GetListOfMountIcons',
					choiceOrder = 'GetListOfMountOrder',
					choiceType = 'dict',
					passValue = prefix .. 'Mount2',
				},
				{
					order = 3,
					type = 'choice',
					name = L.grp_mount_3rd,
					desc = L.grp_mount_3rd_desc,
					choices = function() return self:GetListOfMounts(mode) end,
					choiceIcons = 'GetListOfMountIcons',
					choiceOrder = 'GetListOfMountOrder',
					choiceType = 'dict',
					passValue = prefix .. 'Mount3',
				},
			},
		}
end

function SmartMount:GetSetting(key)
	return self.db.profile[key]
end

function SmartMount:SetSetting(key, value)
	if value == self.db.profile[key] then
		return
	end
	--local oldvalue = self.db.profile[key]
	self.db.profile[key] = value
	if key == 'NormalKey' then
		if value == self.db.profile['AlternateKey'] then
			self.db.profile['AlternateKey'] = false
			Rock('LibRockConfig-1.0'):RefreshConfigMenu(self)
		end
	elseif key == 'AlternateKey' then
		if value == self.db.profile['NormalKey'] then
			self.db.profile['NormalKey'] = false
			Rock('LibRockConfig-1.0'):RefreshConfigMenu(self)
		end
	end

	self:UpdateSettings()
end

local function sort_fly(a, b)
	if a.s == 0 and b.s == 0 then
		-- both fly = 0: just primary speed
		if a.f == b.f then
			return a.m < b.m
		else
			return a.f < b.f
		end -- if
	else
		-- at laest one is flying: check ONLY fly speed
		if a.s == b.s then
			return a.m < b.m
		else
			return a.s < b.s
		end -- if
	end -- if
end

local function sort_fs(a, b)
	if a.f == b.f then
		if a.s == nil or a.s == b.s then
			return a.m < b.m
		else
			return a.s < b.s
		end -- if
	else
		return a.f < b.f
	end -- if
end

local function ppp(n)
	if not n then
		return '--'
	elseif n < 100 then
		return (n - 99) .. '%'
	elseif n > 100 then
		return '+' .. (n - 100) .. '%'
	else
		return '±0%'
	end -- if
end

function SmartMount:GetListOfMounts(mode)
	local MustCanLand = mode == 0
	local MustCanSwim = mode == 1
	local MustCanCombat = mode == 2
	local MustCanSpecial = mode == 3
	local C = self.db.profile
	
	if C.ListOfMounts == nil then
		C.ListOfMounts = {}
	end
	
	for k,v in pairs(C.ListOfMounts) do
		if string.sub(v.action, 1, 5) == 'item:' then
			-- mark mounts as not available
			v.can = false
		else
			-- remove non mounts
			C.ListOfMounts[k] = nil
		end -- if
	end -- for
	
	local mounts = self:CountMounts(true)
	local mountspeed = { [1]={100, false}, [2]={140,false}, [3]={160,false}, [4]={200,false}, [5]={160,160}, [6]={200,380}, [7]={200,410} }
	
	for i=1, 6 do
		for _, v in pairs(mounts[i]) do
			local itemName, _, _, _, _, _, _, _, _, itemTexture = GetItemInfo(v.item)
			C.ListOfMounts[v.item] = { name = itemName,  action = v.item, icon = itemTexture, can = true, land = mountspeed[i][1], fly = mountspeed[i][2], swim = false, combat = false, special = false }
		end -- for
	end -- for
	
	for k, v in pairs(self.SpecialSpells) do
		C.ListOfMounts[k] = { name = v.name,  action = k, icon = v.icon, can = v.can, land = v.land, fly = v.fly, swim = v.swim, combat = v.combat, special = v.special }
	end -- for
	
	local first, second, sortfn, secondbr
	
	if MustCanLand then
		self.chooseMounts = { ['off'] = ' - ' .. self.L['mount_off'] .. ': ' .. ppp(100) .. '' }
		first = 'land'
		second = 'fly'
		sortfn = sort_fly
		secondbr = false
	elseif MustCanSwim then
		self.chooseMounts = { ['off'] = ' - ' .. self.L['mount_off'] .. ': ' .. ppp(66) .. '' }
		first = 'swim'
		second = '__'
		sortfn = sort_fs
		secondbr = false
	elseif MustCanCombat then
		self.chooseMounts = { ['off'] = ' - ' .. self.L['mount_off'] .. ': ' .. ppp(100) .. ' (' .. ppp(66) .. ')' }
		first = 'land'
		second = 'swim'
		sortfn = sort_fs
		secondbr = true
	else -- if MustCanSpecial then
		self.chooseMounts = { ['off'] = ' - ' .. self.L['mount_off'] }
		first = false
		sortfn = sort_fs
	end -- if
	self.chooseMountIcons = { ['off'] = 'Interface\\Icons\\Temp'}
	self.chooseMountOrder = {}
	table.insert(self.chooseMountOrder, {a = 'off', f = -100, s = 0, m = '' })
	if MustCanLand then
		self.chooseMounts['rnd_fast'] = ' ' .. self.L['mount_rnd_fast']
		self.chooseMountIcons['rnd_fast'] = 'Interface\\Icons\\INV_Gizmo_RocketBootExtreme'
		table.insert(self.chooseMountOrder, {a = 'rnd_fast', f = -50, s = 0, m = '' })
		self.chooseMounts['rnd_all'] = ' ' .. self.L['mount_rnd_any']
		self.chooseMountIcons['rnd_all'] = 'Interface\\Icons\\INV_Gizmo_RocketBoot_01'
		table.insert(self.chooseMountOrder, {a = 'rnd_all', f = -25, s = 0, m = '' })
	elseif MustCanSpecial then
		self.chooseMounts['rnd_pet'] = ' - ' .. self.L['mount_rnd_pet']
		self.chooseMountIcons['rnd_pet'] = 'Interface\\Icons\\INV_Jewelcrafting_GoldenHare'
		table.insert(self.chooseMountOrder, {a = 'rnd_pet', f = -50, s = 0, m = '' })
	end -- if
	
	for k, v in pairs(C.ListOfMounts) do
		if (not MustCanCombat or v.combat) and (not MustCanSwim or v.swim) and (not MustCanLand or v.land or v.fly) and (not MustCanSpecial or v.special) then
			local fspeed
			local sspeed
			if first then
				fspeed = v[first]
				sspeed = v[second]
				if secondbr then
					-- 'xxx% (xxx%): '
					self.chooseMounts[v.action] = ' ' .. ppp(fspeed) .. ' (' .. ppp(sspeed) .. '): ' .. v.name
				elseif sspeed then
					-- 'xxx% / xxx%: '
					self.chooseMounts[v.action] = ' ' .. ppp(fspeed) .. ' / ' .. ppp(sspeed) .. ': ' .. v.name
				else
					-- 'xxx%: '
					self.chooseMounts[v.action] = ' ' .. ppp(fspeed) .. ': ' .. v.name
				end -- if
			else
				fspeed, sspeed = 0, 0
				self.chooseMounts[v.action] = ' ' .. v.name
			end -- if
			if v.can then
				self.chooseMountIcons[v.action] = v.icon
			elseif string.sub(k, 1, 5) == 'item:' then
				self.chooseMountIcons[v.action] = 'Interface\\AddOns\\SmartMount\\Icons\\Mount_Item'
			elseif k == 'special:Hook of the Master Angler' then
				self.chooseMountIcons[v.action] = 'Interface\\AddOns\\SmartMount\\Icons\\Special_Hook'
			elseif (v.land and v.land > 100) or (v.fly and v.fly > 100) then
				self.chooseMountIcons[v.action] = 'Interface\\AddOns\\SmartMount\\Icons\\Mount_Spell'
			else
				self.chooseMountIcons[v.action] = 'Interface\\AddOns\\SmartMount\\Icons\\Spell'
			end -- if
			table.insert(self.chooseMountOrder, {a = v.action, f = fspeed or 100, s = sspeed or 0, m = v.name})
		end -- if
	end -- for
	
	table.sort(self.chooseMountOrder, sortfn)
	for k,v in pairs(self.chooseMountOrder) do
		self.chooseMountOrder[k] = v.a
	end -- for
	
	return self.chooseMounts
end

function SmartMount:GetListOfMountIcons()
	return self.chooseMountIcons
end

function SmartMount:GetListOfMountOrder()
	return self.chooseMountOrder
end

function SmartMount:ImportKeys()
	local key1, key2 = GetBindingKey('SMARTMOUNT_MOUNTORCONFIG')
	if key1 then
		SetBinding(key1)
	end -- if
	if key2 then
		SetBinding(key2)
	end -- if
	self.db.profile.NormalKey = key1 or false
	self.db.profile.AlternateKey = key2 or false
	self:UpdateSettings()
	Rock('LibRockConfig-1.0'):RefreshConfigMenu(self)
end
