--[[

	this file contains everything which is required for running the addon WITH rock
	
--]]

function SmartMount:OnEnable()
	self:InitClick()
	self:CheckConfig()
	self:UpdateSettings()
end

function SmartMount:OnDisable()
	SmartMount_Button:Hide()
	ClearOverrideBindings(SmartMount_Button)
	self:SetAttributes(false, {})
	self:SetAttributes(true, {})
end

function SmartMount:UpdateSettings()
	ClearOverrideBindings(SmartMount_Button)
	if self.db.profile['NormalKey'] then
		SetOverrideBindingClick(SmartMount_Button, true, self.db.profile['NormalKey'], 'SmartMount_Button', 'LeftButton')
	end -- if
	if self.db.profile['AlternateKey'] then
		SetOverrideBindingClick(SmartMount_Button, true, self.db.profile['AlternateKey'], 'SmartMount_Button', 'RightButton')
	end -- if
	if self.db.profile['ShowActionButton'] then
		SmartMount_Button:Show()
	else
		SmartMount_Button:Hide()
	end -- if
	self:PostClick(false)
	self:PostClick(true)
end

function SmartMount:OnProfileEnable()
	self:CheckConfig()
	self:UpdateSettings()
end

