--[[
		locale, only if Rock is used!
--]]

if Rock and Rock:HasLibrary('LibRockLocale-1.0') then

	local L = Rock('LibRockLocale-1.0'):GetTranslationNamespace('SmartMount')
	
	L:AddTranslations('enUS', function() return {
		-- translated by
		['Translator'] = true,
		['translated_by'] = [[Nobody]],
		
		-- global keybings
		['Show Options'] = true,

		-- some special spells
		['Travel, Flight or Swift Flight Form'] = true,
		['Flight / Swift Flight Form'] = true,
		['Bear / Dire Bear Form'] = true,

		-- globals
		['Normal Mount'] = true,
		['Alternate Mount'] = true,

		-- config, first page
		['normal_key_desc'] = [[Here you can configure a key which summons the normal mount. See Page 0-3 for more informations.]],
		['alternate_key_desc'] = [[Here you can configure a key which summons the alternate mount. See Page 0-3 for more informations.]],
		['key_helper_name'] = [[Help with Keys]],
		['key_helper_desc'] = [[WARNING:
Use this only if you can't enter the keys you want (e.g. Mouse4, Mouse5, Shift-Mouse3, ...).

The first "Show Options" key from the global key bindings will be "Normal Mount", the second "Show Options" key the "Alternate Mount", and both "Open Config" keys will be unset.

Please use with care!]],
		['key_helper_confirm'] = [[I've read the Tooltip]],
		['key_helper_button'] = [[Import from key bindings]],
		['show_action_button_name'] = [[Show Action Button]],
		['show_action_button_desc'] = [[Left: Normal Mount
Right: Alternate Mount
Shift-Left: Move Button]],
		['debug_name'] = [[Enable Debugging]],
		['debug_desc'] = [[Many debug informations in chat window]],

		-- config, page 0-3
		['grp_normal_desc'] = [[What should happen, if you press the Normal Key / Left Button?]],
		['grp_alternate_desc'] = [[What should happen, if you press the Alternate Key / Right Button?]],
		['grp_dismount'] = [[Dismount]],
		['grp_dismount_desc'] = [[Would you like to dismount and/or mount?]],
		['grp_dismount_yes'] = [[If you're mounted]],
		['grp_dismount_yes_desc'] = [[What should happen, if you're mounted?]],
		['grp_dismount_yes_D_'] = [[Dismount and don't mount]],
		['grp_dismount_yes_DM'] = [[Dismount first, then mount]],
		['grp_dismount_yes___'] = [[Neither dismount nor mount]],
		['grp_dismount_yes__M'] = [[Don't dismount, but mount]],
		['grp_dismount_no'] = [[If not mounted]],
		['grp_dismount_no_desc'] = [[What should happen, if you're NOT mounted?]],
		['grp_dismount_no___'] = [[Don't mount]],
		['grp_dismount_no__M'] = [[Do mount]],
		['grp_dismount_mnt_DM'] = [[Dismount and do the following]],
		['grp_dismount_mnt__M'] = [[Don't dismount, but do the following]],
		['grp_dismount_mnt_DMf'] = [[Dismount and do the following / do nothing at all if flying]],
		['grp_dismount_mnt__Mf'] = [[Don't dismount, but do the following / do noting at all if flying]],
		['grp_mount'] = [[Mount]],
		['grp_mount_desc'] = [[Which mount should be used?]],
		['mount_off'] = [[Don't Mount]],
		['mount_rnd_fast'] = [[Random Mount (fastest)]],
		['mount_rnd_any'] = [[Random Mount (any)]],
		['mount_rnd_pet'] = [[Random Pet (Requires "LibPeriodicTable-3.1")]],
		['grp_mount_1st'] = [[1st choice]],
		['grp_mount_2nd'] = [[2nd choice]],
		['grp_mount_3rd'] = [[3rd choice]],
		['grp_mount_1st2nd_desc'] = [[Which mount?
If this mount is not available, try next.]],
		['grp_mount_3rd_desc'] = [[Which mount?
If this mount is not available noting will happen.]],

		-- config, page 0. combat
		['combat_name'] = [[0. In Combat]],
		['combat_desc'] = [[Here you can set what should be done if you're in combat.]],

		-- config, page 1. swimming
		['swim_name'] = [[1. Swimming]],
		['swim_desc'] = [[Here you can set what should be done if you're swimming.]],

		-- config, page 2. mounted
		['dis_name'] = [[2. Mounted]],
		['dis_desc'] = [[Here you can set what should be done if you're already mounted.]],

		-- config, page 3. do mount
		['land_name'] = [[3. Do Mount]],
		['land_desc'] = [[Here you can set what should be done if you're standing on land.]],
	} end )
	
	L:AddTranslations('deDE', function() return {
		-- translated by
		['Translator'] = [[Übersetzer]],
		['translated_by'] = [[Niemand]],
		
		-- global keybings
		['Show Options'] = [[Zeige Optionen]],

		-- some special spells
		['Travel, Flight or Swift Flight Form'] = [[Reise-/ Flug-/ Schnelle Fluggestalt]],
		['Flight / Swift Flight Form'] = [[Flug- / Schnelle Fluggestalt]],
		['Bear / Dire Bear Form'] = [[Bären- / Terrorbärengestalt]],

		-- globals
		['Normal Mount'] = [[Normales Reittier]],
		['Alternate Mount'] = [[Alternatives Reittier]],

		-- config, first page
		['normal_key_desc'] = [[Hier kannst du eine Taste belegen, welche dein Normales Reittier herbei ruft. Siehe Seite 0-3 für mehr Informationen.]],
		['alternate_key_desc'] = [[Hier kannst du eine Taste belegen, welche dein Alternatives Reittier herbei ruft. Siehe Seite 0-3 für mehr Informationen.]],
		['key_helper_name'] = [[Hilfe bei Tasten]],
		['key_helper_desc'] = [[WARNUNG:
Benutze dieses nur wenn du nicht die Tasten eingeben kannst, die du möchtest (z.B. Maus4, Maus5, Shift-Maus3, ...).

Die erste Taste von "Zeige Optionen" der Globalen Tastaturbelegung wird das "Normales Reittier", die zweite Taste von "Zeige Optionen" wird das "Alternatives Reittier", beide "Zeige Optionen" Tasten werden gelöscht.

Bitte mit Vorsicht benutzen!]],
		['key_helper_confirm'] = [[Hab' den Tooltip gelesen]],
		['key_helper_button'] = [[Importiere von der Tastenbelegung]],
		['show_action_button_name'] = [[Zeige Action Button]],
		['show_action_button_desc'] = [[Links: Normales Reittier
Rechts: Alternatives Reittier
Shift-Links: Bewege Button]],

		-- config, page 0-3
		['grp_normal_desc'] = [[Was soll passieren, wenn die Normale Taste / die Linke Maustaste gedrückt wird?]],
		['grp_alternate_desc'] = [[Was soll passieren, wenn die Alternative Taste / die Rechte Maustaste gedrückt wird?]],
		['grp_dismount'] = [[Absitzen]],
		['grp_dismount_desc'] = [[Willst du absitzen und/oder aufsitzen?]],
		['grp_dismount_yes'] = [[Wenn aufsitzend]],
		['grp_dismount_yes_desc'] = [[Was soll passieren, wenn du aufsitzt?]],
		['grp_dismount_yes_D_'] = [[Absitzen und nicht aufsitzen]],
		['grp_dismount_yes_DM'] = [[Absitzen und dann aufsitzen]],
		['grp_dismount_yes___'] = [[Weder absitzen noch aufsitzen]],
		['grp_dismount_yes__M'] = [[Nicht absitzen, aber aufsitzen]],
		['grp_dismount_no'] = [[Wenn nicht aufsitzend]],
		['grp_dismount_no_desc'] = [[Was soll passieren, wenn du NICHT aufsitzt?]],
		['grp_dismount_no___'] = [[Nicht aufsitzen]],
		['grp_dismount_no__M'] = [[Aufsitzen]],
		['grp_dismount_mnt_DM'] = [[Absitzen und dann mache folgendes]],
		['grp_dismount_mnt__M'] = [[Nicht absitzen, aber mache folgendes]],
		['grp_dismount_mnt_DMf'] = [[Absitzen und dann mache folgendes / mache nichts wenn im flug]],
		['grp_dismount_mnt__Mf'] = [[Nicht absitzen, aber mache folgendes / mache nichts wenn im flug]],
		['grp_mount'] = [[Aufsitzen]],
		['grp_mount_desc'] = [[Welches Reittier soll genutzt werden?]],
		['mount_off'] = 'Nicht aufsitzen',
		['mount_rnd_fast'] = [[Zufälliges Reittier (schnellstes)]],
		['mount_rnd_any'] = [[Zufälliges Reittier (irgendeins)]],
		['mount_rnd_pet'] = [[Zufälliges Haustier (Benötigt "LibPeriodicTable-3.1")]],
		['grp_mount_1st'] = [[1. Wahl]],
		['grp_mount_2nd'] = [[2. Wahl]],
		['grp_mount_3rd'] = [[3. Wahl]],
		['grp_mount_1st2nd_desc'] = [[Welches Reittier?
Wenn dieses Reittier nicht verfügbar ist, probiere nächstes.]],
		['grp_mount_3rd_desc'] = [[Welches Reittier?
Wenn dieses Reittier nicht verfügbar ist wird nichts passieren.]],

		-- config, page 0. combat
		['combat_name'] = [[0. Im Kampf]],
		['combat_desc'] = [[Hier kannst du einstellen, was passieren soll wenn du im Kampf bist.]],

		-- config, page 1. swimming
		['swim_name'] = [[1. Schwimmend]],
		['swim_desc'] = [[Hier kannst du einstellen, was passieren soll wenn du schwimmst.]],

		-- config, page 2. mounted
		['dis_name'] = [[2. Aufsitzend]],
		['dis_desc'] = [[Hier kannst du einstellen, was passieren soll wenn du schon aufsitzt.]],

		-- config, page 3. do mount
		['land_name'] = [[3. Aufsitzen]],
		['land_desc'] = [[Hier kannst du einstellen, was passieren soll wenn du so rum stehst.]],
	} end )
	
end -- if
